import requests
from lxml import etree
import csv
start_url='https://www.xingyueboke.com/sudongpozhuan/'
headers={'User-Agent':'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/123.0.0.0 Safari/537.36 Edg/123.0.0.0'}
def get_source(url=start_url):
    response = requests.get(url,headers=headers)
    if response.status_code==200:
        return response.content.decode('utf-8')
    else:
        print("请求失败，状态码为{}".format(response.status_code))
        return ""
def get_chapter_urls(start_source):
    selector = etree.HTML(start_source)
    urls=selector.xpath('//*[@id="content-list"]/div[2]/ul//a/@href')
    right_url = []
    for url in urls:
        right_url.append(url)
    return right_url
def get_article(article_html):
    selector = etree.HTML(article_html)
    title=selector.xpath('//h1/text()')[0]
    content=selector.xpath('//*[@id="nr1"]/div/p/text()')
    return title,content
def save(title,content):
    filename = title + ".txt"
    with open(filename, "a+", encoding='utf-8') as f:
        f.write(content[0])
def saveCsv(article_list):
    filename = "苏东坡传" + ".csv"
    with open(filename,"w",encoding='utf-8') as file:
        writer=csv.writer(file)
        writer.writerow(["网页地址", "标题", "正文长度"])
        for article in article_list:
            writer.writerow(article)
article_list=[]

if __name__=='__main__':
    source=get_source()
    urls = get_chapter_urls(source)
    for url in urls:
        article_html = get_source(url)
        title, content = get_article(article_html)
        print(title)
        print(content)
        save(title,content)
        article_list.append([url,title,len(content[0])])
    print(source)
    print(urls)
saveCsv(article_list)